routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\RequirementsController;
use App\Http\Controllers\LocationsController;
use App\Http\Controllers\UserController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::middleware([
    'auth:sanctum',
    config('jetstream.auth_session'),
    'verified'
])->group(function () {
    Route::get('/dashboard', function () {
        return view('dashboard');
    })->name('dashboard');
    Route::resource('requirement', RequirementsController::class);
    Route::resource('location', LocationsController::class);
    Route::resource('user', UserController::class);
});

app/Http/Livewire/LocationTable.php
<?php

namespace App\Http\Livewire;

use Carbon\Carbon;
use Livewire\Component;
use App\Models\Forecast;
use App\Models\Sun;

class LocationTable extends Component
{

    public function mount($location)
    {
        $this->location = $location;
    }

    public function render()
    {

        $forecast = Forecast::where('location_id', $this->location->id)->get();
        $sun = Sun::where('location_id', $this->location->id)->get();
        $days = [];

        $offset = Carbon::now($this->location->timezone)->offsetHours;
        $today_timestamp = strtotime(date("Y-m-d"))-($offset*3600);

        $current_timestamp = $today_timestamp;

        $first = $forecast->first();
        $day_data = array();
        $day = 0;
        $hour = 0;
        while($current_timestamp < $first->time) {
            $x = array("Wind Speed"=>"", "Cloud Cover"=>"", "Night"=>"", "Time"=>$current_timestamp);
            $day_data[$day][$hour] = $x;
            $hour++;
            $current_timestamp += 3600;
            if($hour == 24) {
                $day++;
                $hour = 0;
            }

        }

        foreach($forecast as $data) {
            $x = array("Wind Speed"=>intval($data->wind_speed), "Cloud Cover"=>intval($data->cloud_cover*100));
            $sun = Sun::where('location_id', $this->location->id)
                    ->where('day' , "<=",  $current_timestamp)
                    ->orderBy('day', 'desc')
                    ->first();
            if($current_timestamp <= $sun->sunrise || $current_timestamp >= $sun->sunset)
                $x['Night'] = True;
            else 
                $x['Night'] = False;
            $x['Time'] = $current_timestamp;
            $day_data[$day][$hour] = $x;
            $hour++;
            $current_timestamp += 3600;
            if($hour == 24) {
                $day++;
                $hour = 0;
            }           
        }

        return view('livewire.location-table', compact('day_data'));
    }
}

app/Http/Livewire/RequirementForm.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;
use App\Models\Location;
use App\Models\User;
use DB;

class RequirementForm extends Component
{

    public $location_id;
    public $wind_speed;
    public $cloud_cover;
    public $days_ahead;
    public $min_hours;

    public $countries;
    public $states;
    public $cities;

    public $selectedCountry = null;
    public $selectedState = null;
    public $selectedCity = null;

    public function render()
    {
        //$countries = Location::distinct('country')->orderBy('country')->pluck('country')->prepend('Please Select');

        return view('livewire.requirement-form');
    }

    public function mount($selectedCity = null)
    {
        $this->countries = Location::distinct('country')->orderBy('country')->pluck('country');
        $this->states = collect();
        $this->cities = collect();
        $this->selectedCity = $selectedCity;

        if (!is_null($selectedCity)) {
            $city = Location::where('name', $selectedCity);
            if ($city) {
                $this->cities = Location::where('subcountry', $city->subcountry)->orderBy('name')->get();
                $this->states = Location::distinct('subcountry')->where('country', $city->state->country)->orderBy('subcountry')->pluck('subcountry');
                $this->selectedCountry = $city->state->country_id;
                $this->selectedState = $city->state_id;
            }
        }
    }

    public function updatedSelectedCountry($country)
    {
        $this->states = Location::distinct('subcountry')->where('country', $country)->orderBy('subcountry')->pluck('subcountry');
        $this->selectedState = NULL;
    }

    public function updatedSelectedState($state)
    {
        if (!is_null($state)) {
            $this->cities = Location::where('subcountry', $state)->orderBy('name')->get();
        }
    }

    public function save()
    {
        $validated = $this->validate([
            'location_id' => 'required|integer',
            'wind_speed' => 'required|integer',
            'cloud_cover' => 'required|integer|max:100',
            'days_ahead' => 'required|integer|max:15',
            'min_hours' => 'required|integer|max:10',
        ]);

        $user = User::find(auth()->user()->id);
        $result = $user->requirement()->create([
            'location_id' => $validated['location_id'],
            'wind_speed' => $validated['wind_speed'],
            'cloud_cover' => $validated['cloud_cover'],
            'days_ahead' => $validated['days_ahead'],
            'min_hours' => $validated['min_hours']
        ]);

        $location = Location::find($validated['location_id']);
        if($location->lat == "") 
        {
            $url = "http://api.geonames.org/getJSON?username=dpoulson&geonameId=".$location->id;
					  $json = file_get_contents($url);
					  $raw = json_decode($json);
            $updated = DB::table('locations')
                        ->where('id', $location->id)
                        ->update([
                          'lat' => $raw->lat,
                          'lon' => $raw->lng,
                          'timezone' => $raw->timezone->timeZoneId
                        ]);

        }
        return redirect()->route('dashboard')
                        ->with('success','Requirement created successfully.');
    }

}

app/Http/Livewire/RequirementsTable.php
<?php

namespace App\Http\Livewire;
use App\Models\Requirement;

use Livewire\Component;

class RequirementsTable extends Component
{

    protected $listeners = ['delete'];

    public function render()
    {
        $requirements = auth()->user()->requirement;
        return view('livewire.requirements-table', compact('requirements'));
    }

    public function delete($id)
    {
        $requirement = Requirement::find($id);
        if ($requirement->user_id == auth()->user()->id) 
        {
            $requirement->delete();
        }
        $this->dispatchBrowserEvent('requirement-deleted');
    }
}

app/Http/Livewire/ResultsTable.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;

class ResultsTable extends Component
{
    public function render()
    {
        $requirements = auth()->user()->requirement;
        return view('livewire.results-table', compact('requirements'));
    }
}

resources/views/livewire/location-table.blade.php
<div>
@if ($location->lat != "")
        <table class="min-w-max w-full table-auto">
            <thead>
                <tr class="px-1 bg-gray-200 text-gray-600 uppercase text-xs leading-normal">
                    <th class="p-0 px-1 text-center">Day</th>
                    <th class="p-0 text-center"></th>
                    <th class="p-0 px-1 text-center">00:00</th>
                    <th class="p-0 px-1 text-center">01:00</th>
                    <th class="p-0 px-1 text-center">02:00</th>
                    <th class="p-0 px-1 text-center">03:00</th>
                    <th class="p-0 px-1 text-center">04:00</th>
                    <th class="p-0 px-1 text-center">05:00</th>
                    <th class="p-0 px-1 text-center">06:00</th>
                    <th class="p-0 px-1 text-center">07:00</th>
                    <th class="p-0 px-1 text-center">08:00</th>
                    <th class="p-0 px-1 text-center">09:00</th>
                    <th class="p-0 px-1 text-center">10:00</th>
                    <th class="p-0 px-1 text-center">11:00</th>
                    <th class="p-0 px-1 text-center">12:00</th>
                    <th class="p-0 px-1 text-center">13:00</th>
                    <th class="p-0 px-1 text-center">14:00</th>
                    <th class="p-0 px-1 text-center">15:00</th>
                    <th class="p-0 px-1 text-center">16:00</th>
                    <th class="p-0 px-1 text-center">17:00</th>
                    <th class="p-0 px-1 text-center">18:00</th>
                    <th class="p-0 px-1 text-center">19:00</th>
                    <th class="p-0 px-1 text-center">20:00</th>
                    <th class="p-0 px-1 text-center">21:00</th>
                    <th class="p-0 px-1 text-center">22:00</th>
                    <th class="p-0 px-1 text-center">23:00</th>
                </tr>
            </thead>
            <tbody class="text-gray-300 text-xs font-light">
                @foreach ($day_data as $day)
                    <tr class="border-b border-gray-300 hover:bg-gray-700">
                        <th class="p-2 text-center">{{ date('Y-m-d', $day[0]['Time']) }}</th>
                        <th class="p-2 text-center"><i class="fa-solid fa-wind"></i><br /><i class="fa-solid fa-cloud"></i></th>
                        @foreach ($day as $hour)
                            @if ($hour['Night'])
                                <td class="p-0 p-3 dark:bg-gray-400 text-gray-600 text-left whitespace-nowrap">
                            @else
                                <td class="p-0 p-3 dark:bg-gray-600 text-gray-500 text-left whitespace-nowrap">
                            @endif
                                @if($hour['Wind Speed'] == "")
                                    NA
                                @else
                                    {{ $hour['Wind Speed'] }} <br /> 
                                    {{ intval($hour['Cloud Cover']) }}
                                @endif
                            </td>

                        @endforeach
                    </tr>
                @endforeach
            </tbody>
        </table>
@else
            <div class="alert alert-warning">
                Location Unknown
            </div>
@endif

</div>

resources/views/livewire/requirement-form.blade.php
<div>
    <form wire:submit.prevent="save">
    <div class="row">
    <div class="col-lg-6 mx-5">
    <div>
    <div class="mb-3 row">

        <label for="country">Country</label>

        <div class="col-md-6">
            <select wire:model="selectedCountry" class="mt-1 block w-full dark:text-gray-800">
                <option value="" selected>Select Country</option>
                @foreach($countries as $country)
                    <option value="{{ $country }}">{{ $country }}</option>
                @endforeach
            </select>
        </div>
    </div>
    @if (!is_null($selectedCountry))
        <div class="mb-3 row">
            <label for="state">State</label>

            <div class="col-md-6">
                <select wire:model="selectedState" class="mt-1 block w-full dark:text-gray-800">
                    <option value="" selected>Choose State</option>
                    @foreach($states as $state)
                        <option value="{{ $state }}">{{ $state }}</option>
                    @endforeach
                </select>
            </div>
        </div>
    @endif

    @if (!is_null($selectedState))
        <div class="mb-3 row">
            <label for="city">City</label>

            <div class="col-md-6">
                <select wire:model="location_id" class="mt-1 block w-full dark:text-gray-800" id="location_id" name="location_id">
                    <option value="test" selected>Choose City</option>
                    @foreach($cities as $city)
                        <option value="{{ $city->id }}">{{ $city->name }}</option>
                    @endforeach
                </select>
            </div>
        </div>
    @endif

  </div>  
  
  <div class="row">
    <div class="col-lg-6 mx-5">
      <div class="form-group">
        <label for="wind_speed">Wind Speed (mph):</label>
        <input type="number" name="wind_speed" id="wind_speed" class="mt-1 block w-full dark:text-gray-800" wire:model="wind_speed">
        @error('wind_speed') <span class="text-danger">{{ $message }}</span> @enderror
      </div>
    </div>
  </div>

  <div class="row">
    <div class="col-lg-6 mx-5">
      <div class="form-group">
      <label for="cloud_cover">Cloud Cover (%):</label>
        <input type="number" name="cloud_cover" id="cloud_cover" class="mt-1 block w-full dark:text-gray-800" wire:model="cloud_cover">
        @error('cloud_cover') <span class="text-danger">{{ $message }}</span> @enderror
      </div>
    </div>
  </div>
  
  <div class="row">
    <div class="col-lg-6 mx-5">
      <div class="form-group">
        <label for="days_ahead">Days Ahead:</label>
        <input type="number" name="days_ahead" id="days_ahead" class="mt-1 block w-full dark:text-gray-800" wire:model="days_ahead">
        @error('days_ahead') <span class="text-danger">{{ $message }}</span> @enderror
      </div>
    </div>
  </div>
  
  <div class="row">
    <div class="col-lg-6 mx-5">
      <div class="form-group">
        <label for="min_hours">Min Hours:</label>
        <input type="number" name="min_hours" id="min_hours" class="mt-1 block w-full dark:text-gray-800" wire:model="min_hours">
        @error('min_hours') <span class="text-danger">{{ $message }}</span> @enderror
      </div>
    </div>
  </div>
  
  <div class="row">
    <div class="col-lg-6 mx-5">
      <x-jet-button type="submit" class="btn btn-primary">Submit</x-jet-button>
    </div>
  </div>

    </form>
</div>

resources/views/livewire/requirements-table.blade.php
<div>
        @if ($requirements->count())
        <table class="min-w-max w-full table-auto">
            <thead>
                <tr class="bg-gray-200 text-gray-600 uppercase text-sm leading-normal">
                    <th class="p-3 p-6 text-center">Location</th>
                    <th class="p-3 p-6 text-center">Wind Speed</th>
                    <th class="p-3 p-6 text-center">Cloud Cover</th>
                    <th class="p-3 p-6 text-center">Days Ahead</th>
                    <th class="p-3 p-6 text-center">Min Hours</th>
                    <th class="p-3 p-6 text-center"></th>
                </tr>
            </thead>
            <tbody class="text-gray-300 text-sm font-light">
                @foreach ($requirements as $requirement)
                    <tr class="border-b border-gray-300 hover:bg-gray-700">
                        <td class="p-3 p-6 text-center whitespace-nowrap">
                            <a href="{{ route('location.show', ['location' => $requirement->location->id] )}}">
                                {{ $requirement->location->name }}
                            </a>
                        </td>
                        <td class="p-3 p-6 text-center whitespace-nowrap">{{ $requirement->wind_speed }}</td>
                        <td class="p-3 p-6 text-center whitespace-nowrap">{{ $requirement->cloud_cover }}</td>
                        <td class="p-3 p-6 text-center whitespace-nowrap">{{ $requirement->days_ahead }}</td>
                        <td class="p-3 p-6 text-center whitespace-nowrap">{{ $requirement->min_hours }}</td>
                        <td>
                        <x-jet-danger-button wire:click="$emit('confirmDelete', {{ $requirement->id }})" wire:loading.attr="disabled">
                            Delete
                            </x-jet-danger-button>
                        </td>
                    </tr>
                @endforeach
            </tbody>
        </table>
        @else
            <div class="alert alert-warning">
                Your query returned zero results.
            </div>
        @endif

        <div class="float-left mt-5">
            <x-action-link href="{{ route('requirement.create') }}">Create New Requirement</x-action-link>
        </div>
  
</div>

resources/views/livewire/results-table.blade.php
<div>
    @php
        $results = 0;
    @endphp
    @foreach($requirements as $requirement)
        @if ($requirement->clearSkies() != NULL)
            @php
                $results++
            @endphp 
            <li>{{ $requirement->clearSkies()[0]['hours']}} hour(s) at {{ $requirement->clearSkies()[0]['start_time']}}. Location: {{ $requirement->location->name }}
        @endif
    @endforeach
    @if ( $results == 0 )
        No results. :(
    @endif
</div>